#!/usr/bin/env python3

# bron: https://en.wikipedia.org/wiki/Merge_sort
# bron: https://stackoverflow.com/questions/18761766/mergesort-with-python

#_______________________________________________________________________________
def mijnMergeSort(reeks: list) -> list:
    ## Deze functie krijgt een lijst binnen die niet noodzakelijk gesorteerd is,
    ##     en geeft een gesorteerde lijst terug.
    ## aangepast, maar gebaseerd op https://stackoverflow.com/a/39683605
    pass

    # [1a] De "base case": als er maar eentje overblijft, is het gesorteerd.
    #     Dus: check of de lengte gelijk is aan een, en indien ja, geef gewoon de lijst terug.

        ## Fase 1: "Split", het opsplitsen
    # [1b]... anders: splits het op in twee evenmatige reksen
        # [2] vind het middelpunt van de reeks, als index
        # [3] splits de reeks op in twee deelreeksen: een linke en een rechte
        # [4] ga zeker dat de deelreeksen gesorteerd zijn: verwerk ze eens met de functie `mijnMergeSort(reeks)`!

    ## Fase 2: "Merge", het samenvoegen
    # hier gaan we dan de twee reeksen samenvoeren en daarbij sorteren.

    # [5] twee indices aanmaken, eentje voor de "linke" helft, eentje voor "rechts"; allebij starten bij null.

    # [6] maak er een lege "result" lijst aan.

    # het samenvoegen van de twee arrays:
    #     we gaan met een while index over de twee gesorteerde reeksen, van links naar rechts
    #     en voegen telkens het kleinere van de twee elementen waar we aan het kijken zijn aan de "results" aan.
    # [7] ga door een "while" loop, die kijkt of een van de indices al volledig door de bijhorende reeks gegaan is
    #     (dus, kijk dat de index kleiner is als de lengte van links|rechts).

        # [8] vergelijk de elementen links en rechts.
            # [9] als het element links kleiner is dan rechts, voeg het aan het resultaat
            # [10] en verhoog de linkse loopindex om 1.
        # [11+12] anders voeg het rechte element aan, en verhoog de rechtse index

    # [13] dan moeten we nog de overblijfsels van "links" en "rechts" aan het "result" aanvoegen

    # viola!
    # [14] geef het resultaat terug.


#_______________________________________________________________________________
# Noot: er is python-code op de nederlandstalige wikipedia
#       voor een BUBBLESORT:
#       https://nl.wikipedia.org/wiki/Bubblesort#Implementatie_in_Python
def wikiBubbleSort(rij: list) -> list:
    # bron: https://nl.wikipedia.org/wiki/Bubblesort
    offset = 1
    verwisseld = True
    while verwisseld:                       #Lus terwijl dingen verwisselen
        verwisseld = False
        for i in range(len(rij)-offset):
            if rij[i] > rij[i+1]:
                rij[i], rij[i+1] = rij[i+1], rij[i] #swap
                verwisseld = True
        offset += 1

    return rij


# Noot: er is python-code op de nederlandstalige wikipedia
#       ook voor MERGESORT
#       https://nl.wikipedia.org/wiki/Mergesort#Python-code
def wikiMergeSort(rij):
    if len(rij) <= 1:
        return rij                      #stopconditie
    midd = int(len(rij)/2)
    links = wikiMergeSort(rij[:midd])       #recursieve oproep op linkerdeel
    rechts = wikiMergeSort(rij[midd:])      #recursieve oproep op rechterdeel
    teller = 0
    while len(links)!=0 and len(rechts)!=0:
        if links[0] < rechts[0]:         #vergelijk de eerste van links met de eerste van rechts
            rij[teller] = links.pop(0)   #verwijder eerste van links en plak ze in de rij
        else:
            rij[teller] = rechts.pop(0)  #verwijder eerste van rechts en plak ze in de rij
        teller += 1
    return rij[:-len(links+rechts)] + links + rechts  #of links of rechts is leeg, dus dit kan


#_______________________________________________________________________________
def PrintLongArray(reeks):
    # een lange reeks afprinten

    if len(reeks) <= 20:
        print (reeks)

    else:
        mid = len(reeks)//2
        ToStr = lambda rks: ",".join(map(str, rks))
        print('[', ToStr(reeks[:5]), '...', ToStr(reeks[mid-2:mid+3]), '...', ToStr(reeks[-5:]), ']')


def TestEenSort(SortFunction, test_reeks: list) -> float:
    # Deze functie is een test-functie voor een sorteeralgoritme.
    # Ze krijgt een sorteerfunctie binnen en een testreeks

    from random import shuffle
    from datetime import datetime as DT

    tic = DT.now()
    shuffle(test_reeks)

    PrintLongArray(test)
    result = SortFunction(test)
    PrintLongArray(result)

    return (DT.now() - tic)


#_______________________________________________________________________________
# Er zijn nu vier sorteer-algoritmes.
# (a): de naive sort met loops ("Brute Force")
# (b): de "WikiMergeSort()" van Wikipedia
# (c): jouw eigen functie!
# (d): python "sorted(lijst)"
# opdracht: Welke van de algoritmes de snelste?
#       Maak er ook stapwijs langere test-arrays (met nummers) aan.
#       Gebruik "matplotlib" om het resultaat te visualiseren.

if __name__ == "__main__":
    test = [chr(ord('a')+n) for n in range(26)]
    print(TestEenSort(sorted, test))

    # noot: ga vanaf 1e4 = 10000 heel voorzichtig vooruit.
    test = [n for n in range(int(1e4))]
    print(TestEenSort(wikiBubbleSort, test))
    print(TestEenSort(wikiMergeSort, test))
    print(TestEenSort(mijnMergeSort, test))
    print(TestEenSort(sorted, test))
